// Inicializamos las variables globales
var sessionCode = '';
var mago = '';
var avatar = '';

// Mostramos el formulario en la aplicación
init_form();

// Función de inicialización del chat
function init_chat(){
    $("#p_input").keyup(function(event) {
        if (event.keyCode === 13) {
            $("#btn_send").click();
        }
    });
    document.getElementById("p_chat").innerHTML = "<b>&nbspChat con el Mago " + mago +":</b>";
    document.getElementById("p_input").focus();

}

// Función de inicialización del formulario
function init_form(){
    $("#nombre").focus();
    $("#nombre").keyup(function(event) {
        if (event.keyCode === 13) {
            $("#btn_join").click();
        }
    });
    $("#edad").keyup(function(event) {
        if (event.keyCode === 13) {
            $("#btn_join").click();
        }
    });
    $("#codigo").keyup(function(event) {
        if (event.keyCode === 13) {
            $("#btn_join").click();
        }
    });
}

// Función para de comprobación del texto del chat
function sendText() {
    
    var text = document.getElementById("p_input").value;
    var usuario = "Yo";

    if(text != ""){
        sendChat(text);
    }
    document.getElementById("p_input").value = "";
    document.getElementById("p_input").focus();
}  

// Función para enviar el texto del chat al mago
function sendChat(mensaje){
    var pack = {
        type: "chat",
        user: document.getElementById("nombre").value,
        chat: mensaje
    }
    write_chat("Yo", mensaje);
    server.sendMessage(pack);
}

// Valida los campos del formulario
validate_form = function (){
    
    var nombre = document.getElementById("nombre");
    var edad = document.getElementById("edad");
    var codigo = document.getElementById("codigo");

    var error_nombre = document.getElementById("error_nombre");
    var error_edad = document.getElementById("error_edad");
    var error_codigo = document.getElementById("error_codigo");


    if(nombre.value == ""){
        error_nombre.innerHTML = "Nombre obligatorio";
        nombre.classList.add("input_error");
        edad.classList.remove("input_error");
        codigo.classList.remove("input_error");
        error_edad.innerHTML = "";
        error_codigo.innerHTML = "";
        nombre.focus();
        return false;
    }
    else if(edad.value == ""){
        error_edad.innerHTML = "Edad obligatoria";
        error_nombre.innerHTML = "";
        error_codigo.innerHTML = "";
        nombre.classList.remove("input_error");
        codigo.classList.remove("input_error");
        edad.classList.add("input_error");
        edad.focus();
        return false;
    }
    else if(codigo.value == ""){
        error_codigo.innerHTML = "Código obligatorio";
        error_nombre.innerHTML = "";
        error_edad.innerHTML = "";
        nombre.classList.remove("input_error");
        edad.classList.remove("input_error");
        codigo.classList.add("input_error");
        codigo.focus();
        return false;
    }
    else if(codigo.value != sessionCode){
        error_codigo.innerHTML = "Código incorrecto";
        codigo.value = "";
        error_nombre.innerHTML = "";
        error_edad.innerHTML = "";
        nombre.classList.remove("input_error");
        edad.classList.remove("input_error");
        codigo.classList.add("input_error");
        codigo.focus();
        return false;
    }
    return true;
}

// Envia la información al mago cuando se conecta
function send_info(){
    if(validate_form()){
        var pack = {
            type: "info",
            name: document.getElementById("nombre").value,
            age: document.getElementById("edad").value
        }
        server.sendMessage(pack);
        load_userchat();
        init_chat();
    }
}

// Carga la sala de la sesión si se ha conectado correctamente
function load_userchat(){
    document.getElementById('container').style.display = "none";
    document.getElementById('half').style.display = "";
    
    init_videos();
}

// Devuelve la hora actual
getTime = function (){
    var today = new Date();
    var hh = today.getHours();
    var mm = today.getMinutes();
    var ss = today.getSeconds();

    return hh + ':' + mm + ':' + ss;
}

// Asigna las variables globales con la información del mago
function write_caracteristicas(mensaje){
    
    sessionCode = mensaje.codigo;
    mago = mensaje.name;
    avatar = mensaje.av;
}

// Oculta los videos de animaciones
function hideVideos(){
    var videos = document.getElementsByName("video_ani");
    for(var i = 0; i < videos.length; i++){
        videos[i].style.display = "none";
        videos[i].currentTime = 0;
    }
}

// Inicializa los videos y reproduce el video por defecto
function init_videos(){

    var botons_ani = ["Normal", "Saludar", "Enfadado", "Secreto", "Llamada", "Señalar", "Si", "No", "Aplaudir", "Pisar", "Desacuerdo"];

    for(var i=0; i < botons_ani.length; i++){
        var video = document.createElement("video");
        video.id = "vid_".concat(botons_ani[i]);
        video.className = "video";
        video.setAttribute("name","video_ani");
        video.loop = true;
        if(i == 0){
            video.autoplay = true;
        } else{
            video.style.display = "none";
        }
        var source = document.createElement("source");
        source.src = "animations/" + avatar + "/" + botons_ani[i] +".mp4";
        source.type = "video/mp4";
        video.appendChild(source);
        document.getElementById("avatar").appendChild(video);
    }
}

// Escribe un mensaje en el chat
function write_chat(usuario, mensaje){
    var chat = document.getElementById("p_chat");
    chat.innerHTML += "<br>&nbsp<b>" + usuario + "</b> <i>" + getTime() + "</i> - " + mensaje;
    chat.scrollTop = chat.scrollHeight;
}

// Muestra el video seleccionado por el mago en la interfaz del usuario
function change_animation(ani){
    var video = document.getElementById("vid_".concat(ani));
    hideVideos();
    video.style.display = "block";
    $("#vid_".concat(ani))[0].play();
}

// Muestra el chat
function chatOn(){
    document.getElementById('chat').style.display = "block";
    document.getElementById('chatOff').style.display = "none";
    $("#p_input").focus();
    $("#p_input").keyup(function(event) {
        if (event.keyCode === 13) {
            $("#btn_send").click();
        }
    });
}

//Oculta el chat
function chatOff(){
    document.getElementById('chat').style.display = "none";
    document.getElementById('chatOff').style.display = "block";
}