    
<div class="container forms" id="container" style="height: 95%; display: block;">
    <h2 style="text-align: center">Registro</h2>
    <div class="form-vertical" id="registerform" autocomplete="off"> 
    <div class="form-group">
        <label class="control-label col-sm-2">Nombre:</label>
        <div class="col-sm-10">
        <input required type="text" class="form-control input_form" id="nombre" placeholder="Introduzca nombre" name="nombre">
        <span id="error_nombre" class="help-block"></span>
        </div>
    </div>
    <div class="form-group">
        <label class="control-label col-sm-8">Contraseña:</label>
        <div class="col-sm-10">          
        <input required type="password" class="form-control input_form" id="password" placeholder="Introduzca contraseña" name="password"></input>
        <span id="error_password" class="help-block"></span>
        </div>
    </div>
    <div class="form-group">
        <label class="control-label col-sm-8">Repita contraseña:</label>
        <div class="col-sm-10">          
        <input required type="password" class="form-control input_form" id="password2" placeholder="Repita contraseña" name="password2"></input>
        <span id="error_password2" class="help-block"></span>
        </div>
    </div>
    <div class="form-group">
        <label class="control-label col-sm-8">E-mail:</label>
        <div class="col-sm-10">          
        <input required type="mail" class="form-control input_form" id="email" placeholder="Introduzca e-mail" name="email"></input>
        <span id="error_email" class="help-block"></span>
        </div>
    </div>
    <div class="form-group">        
        <div class="col-sm-offset-2 col-sm-10">
            <button type="submit" id="btn_register" class="btn btn-default buttons" onclick="register()" style="margin-bottom: 20px">Entrar</button>
            <a id="link_form" href="javascript:form_login()">Iniciar sesión</a>
        </div>
    </div>
</div>

<style>
    #link_form{
        float: right; 
        line-height: 45px;
    }

    #link_form:hover{
        text-decoration: none;
        color: green;
    }

    .forms{
        background-color: #91DBDE;
        background-image: url("https://www.transparenttextures.com/patterns/broken-noise.png");
        width: 400px;
        align-content: center;
        margin-top: 10%;
        margin-bottom: 10%;
        display: none;
    }
</style>

<script>

    // Inicializamos el formulario
    init_form();    
    
    // Inicializa el formulario con los siguientes métodos
    function init_form(){
        nombre.focus();
        $("#nombre").keyup(function(event) {
            if (event.keyCode === 13) {
                $("#btn_register").click();
            }
        });
        $("#password").keyup(function(event) {
            if (event.keyCode === 13) {
                $("#btn_register").click();
            }
        });
        $("#password2").keyup(function(event) {
            if (event.keyCode === 13) {
                $("#btn_register").click();
            }
        });
        $("#email").keyup(function(event) {
            if (event.keyCode === 13) {
                $("#btn_register").click();
            }
        });
    }

    // Registramos al usuario en caso de que los datos sean correctos
    function register(){
        if(validate_form()){
            exeInsertWizard();
        }
    }

    // Carga el formulario de iniciar sesión
    function form_login(){
        $("#body").load("login.php");
    }

    // Valida los campos introducidos en el formulario
    validate_form = function (){
    
        var nombre = document.getElementById("nombre");
        var pass = document.getElementById("password");
        var pass2 = document.getElementById("password2");
        var email = document.getElementById("email");

        var error_nombre = document.getElementById("error_nombre");
        var error_pass = document.getElementById("error_password");
        var error_pass2 = document.getElementById("error_password2");
        var error_email = document.getElementById("error_email");

        if(nombre.value == ""){
            error_nombre.innerHTML = "Nombre obligatorio";
            error_pass.innerHTML = "";
            error_pass2.innerHTML = "";
            error_email.innerHTML = "";
            nombre.focus();
            nombre.classList.add("input_error");
            pass.classList.remove("input_error");
            pass2.classList.remove("input_error");
            email.classList.remove("input_error");
            return false;
        }
        else if(pass.value == ""){
            error_pass.innerHTML = "Contraseña obligatoria";
            error_nombre.innerHTML = "";
            error_pass2.innerHTML = "";
            error_email.innerHTML = "";
            pass.focus();
            pass.classList.add("input_error");
            nombre.classList.remove("input_error");
            pass2.classList.remove("input_error");
            email.classList.remove("input_error");
            return false;
        } else if(pass2.value == "" || pass.value != pass2.value){
            error_pass2.innerHTML = "Repita su contraseña";
            error_pass.innerHTML = "";
            error_nombre.innerHTML = "";
            error_email.innerHTML = "";        
            pass2.focus();
            pass2.value == "";
            pass2.classList.add("input_error");
            pass.classList.remove("input_error");
            nombre.classList.remove("input_error");
            email.classList.remove("input_error");
            return false;
        } else if(email.value == ""){
            error_email.innerHTML = "E-mail obligatorio";
            error_pass2.innerHTML = "";
            error_pass.innerHTML = "";
            error_nombre.innerHTML = "";
            email.focus();
            email.classList.add("input_error");
            nombre.classList.remove("input_error");
            pass2.classList.remove("input_error");
            pass.classList.remove("input_error");
            return false;
        } else if(email.value.search(/^[\w-\.]+@([\w-]+\.)+[\w-]{2,4}$/ig)){
            error_email.innerHTML = "E-mail incorrecto";
            error_pass2.innerHTML = "";
            error_pass.innerHTML = "";
            error_nombre.innerHTML = "";
            email.focus();
            email.classList.add("input_error");
            nombre.classList.remove("input_error");
            pass2.classList.remove("input_error");
            pass.classList.remove("input_error");
            return false;
        }
        return true;
    }

    // Registra un nuevo usuario con los datos introducidos y comprobados en la base de datos
    function exeInsertWizard (){

        var nombre = document.getElementById("nombre").value;
        var pass = document.getElementById("password").value;
        var email = document.getElementById("email").value;

        $.ajax({
            url: 'exeinsertuser.php',
            type: 'POST',
            data: 'nombre=' + nombre + '&pass=' + pass + '&email=' + email,
        success: function (data, textStatus, xhr) {
                alert("Te has registrado correctamente! Inicia sesión para continuar.");
                form_login();
            },
        error: function (xhr, textStatus, errorThrown) {
            alert(textStatus);
            }
        });
    }

</script>